Index: trunk/VUT/GtpVisibilityPreprocessor/src/VssTree.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/VssTree.cpp	(revision 433)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/VssTree.cpp	(revision 434)
@@ -851,18 +903,33 @@
       ri < node->rays.end();
       ri++) {
-    bool positive = (*ri).mRay->HasPosDir(axis);
-    splitCandidates->push_back(SortableEntry(positive ? SortableEntry::ERayMin :
-																						 SortableEntry::ERayMax,
-																						 (*ri).ExtrapOrigin(axis),
-																						 (void *)&*ri)
-															 );
-		
-    splitCandidates->push_back(SortableEntry(positive ? SortableEntry::ERayMax :
-																						 SortableEntry::ERayMin,
-																						 (*ri).ExtrapTermination(axis),
-																						 (void *)&*ri)
-															 );
-  }
-	
+	if ((*ri).mRay->IsActive()) {
+	  if (axis < 3) {
+		bool positive = (*ri).mRay->HasPosDir(axis);
+		splitCandidates->push_back(SortableEntry(positive ? SortableEntry::ERayMin :
+												 SortableEntry::ERayMax,
+												 (*ri).ExtrapOrigin(axis),
+												 (void *)(*ri).mRay)
+								   );
+				
+		splitCandidates->push_back(SortableEntry(positive ? SortableEntry::ERayMax :
+												 SortableEntry::ERayMin,
+												 (*ri).ExtrapTermination(axis),
+												 (void *)(*ri).mRay)
+								   );
+	  } else {
+		float pos = (*ri).mRay->GetDirParametrization(axis-3);
+		splitCandidates->push_back(SortableEntry(SortableEntry::ERayMin,
+												 pos - Limits::Small,
+												 (void *)(*ri).mRay)
+								   );
+				
+		splitCandidates->push_back(SortableEntry(SortableEntry::ERayMax,
+												 pos + Limits::Small,
+												 (void *)(*ri).mRay)
+								   );
+	  }
+	}
+  }
+
   stable_sort(splitCandidates->begin(), splitCandidates->end());
 }
@@ -879,20 +946,20 @@
     stat.maxDepthNodes++;
   
-	//  if ( (int)(leaf->rays.size()) < termMinCost)
-	//    stat.minCostNodes++;
-	if ( leaf->GetPvsSize() < termMinPvs)
-		stat.minPvsNodes++;
-
-	if ( leaf->GetPvsSize() < termMinRays)
-		stat.minRaysNodes++;
-
-	if (0 && leaf->GetAvgRayContribution() > termMaxRayContribution )
-		stat.maxRayContribNodes++;
-	
-	if (SqrMagnitude(data.bbox.Size()) <= termMinSize) {
-		stat.minSizeNodes++;
-	}
-
-	if ( (int)(leaf->rays.size()) > stat.maxRayRefs)
+  //  if ( (int)(leaf->rays.size()) < termMinCost)
+  //    stat.minCostNodes++;
+  if ( leaf->GetPvsSize() < termMinPvs)
+	stat.minPvsNodes++;
+
+  if ( leaf->GetPvsSize() < termMinRays)
+	stat.minRaysNodes++;
+
+  if (0 && leaf->GetAvgRayContribution() > termMaxRayContribution )
+	stat.maxRayContribNodes++;
+	
+  if (SqrMagnitude(data.bbox.Size()) <= termMinSize) {
+	stat.minSizeNodes++;
+  }
+
+  if ( (int)(leaf->rays.size()) > stat.maxRayRefs)
     stat.maxRayRefs = leaf->rays.size();
 
@@ -902,9 +969,11 @@
 VssTree::TerminationCriteriaSatisfied(VssTreeLeaf *leaf)
 {
-	return ( (leaf->GetPvsSize() < termMinPvs) ||
-					(leaf->rays.size() < termMinRays) ||
-					//			 (leaf->GetAvgRayContribution() > termMaxRayContribution ) ||
-					(leaf->depth >= termMaxDepth) ||
-					SqrMagnitude(GetBBox(leaf).Size()) <= termMinSize );
+  return ( (leaf->GetPvsSize() < termMinPvs) ||
+		   (leaf->rays.size() < termMinRays) ||
+		   //			 (leaf->GetAvgRayContribution() > termMaxRayContribution ) ||
+		   (leaf->depth >= termMaxDepth) ||
+		   (SqrMagnitude(GetBBox(leaf).Size()) <= termMinSize) ||
+		   (mUseRss && leaf->mPassingRays == leaf->rays.size())
+		   );
 }
 
@@ -912,36 +981,36 @@
 VssTreeNode *
 VssTree::SubdivideNode(
-											 VssTreeLeaf *leaf,
-											 const AxisAlignedBox3 &box,
-											 AxisAlignedBox3 &backBBox,
-											 AxisAlignedBox3 &frontBBox
-											 )
-{
-  
-	if (TerminationCriteriaSatisfied(leaf)) {
+					   VssTreeLeaf *leaf,
+					   const AxisAlignedBox3 &box,
+					   AxisAlignedBox3 &backBBox,
+					   AxisAlignedBox3 &frontBBox
+					   )
+{
+  
+  if (TerminationCriteriaSatisfied(leaf)) {
 #if 0
-		if (leaf->depth >= termMaxDepth) {
-			cout<<"Warning: max depth reached depth="<<(int)leaf->depth<<" rays="<<leaf->rays.size()<<endl;
-			cout<<"Bbox: "<<GetBBox(leaf)<<" dirbbox:"<<GetDirBBox(leaf)<<endl;
-		}
+	if (leaf->depth >= termMaxDepth) {
+	  cout<<"Warning: max depth reached depth="<<(int)leaf->depth<<" rays="<<leaf->rays.size()<<endl;
+	  cout<<"Bbox: "<<GetBBox(leaf)<<" dirbbox:"<<GetDirBBox(leaf)<<endl;
+	}
 #endif
 		
-		return leaf;
-	}
-	
-	float position;
-	
-	// first count ray sides
+	return leaf;
+  }
+	
+  float position;
+	
+  // first count ray sides
   int raysBack;
   int raysFront;
-	int pvsBack;
-	int pvsFront;
+  int pvsBack;
+  int pvsFront;
 	
   // select subdivision axis
   int axis = SelectPlane( leaf, box, position, raysBack, raysFront, pvsBack, pvsFront);
-	//	cout<<axis<<" ";
-	
-	//	cout<<"rays back="<<raysBack<<" rays front="<<raysFront<<" pvs back="<<pvsBack<<" pvs front="<<
-	//		pvsFront<<endl;
+  //	cout<<axis<<" ";
+	
+  //	cout<<"rays back="<<raysBack<<" rays front="<<raysFront<<" pvs back="<<pvsBack<<" pvs front="<<
+  //		pvsFront<<endl;
 
   if (axis == -1) {
@@ -964,7 +1033,5 @@
 
   VssTreeLeaf *back = new VssTreeLeaf(node, raysBack);
-	back->SetPvsSize(pvsBack);
   VssTreeLeaf *front = new VssTreeLeaf(node, raysFront);
-	front->SetPvsSize(pvsFront);
 
   // replace a link from node's parent
@@ -975,43 +1042,43 @@
 	
   if (axis <= VssTreeNode::SPLIT_Z) {
-		backBBox.SetMax(axis, position);
+	backBBox.SetMax(axis, position);
     frontBBox.SetMin(axis, position);
 		
-		for(VssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
-				ri != leaf->rays.end();
-				ri++) {
+	for(VssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
+		ri != leaf->rays.end();
+		ri++) {
       if ((*ri).mRay->IsActive()) {
 				
-				// first unref ray from the former leaf
-				(*ri).mRay->Unref();
-
-				Debug << "computed t: " << (*ri).mRay->mT << endl;
-				// determine the side of this ray with respect to the plane
-				int side = node->ComputeRayIntersection(*ri, (*ri).mRay->mT);
-
-				if (side == 0) {
-					if ((*ri).mRay->HasPosDir(axis)) {
-						back->AddRay(VssTreeNode::RayInfo((*ri).mRay,
-																							(*ri).mMinT,
-																							(*ri).mRay->mT)
-												 );
-						front->AddRay(VssTreeNode::RayInfo((*ri).mRay,
-																							 (*ri).mRay->mT,
-																							 (*ri).mMaxT));
-					} else {
-						back->AddRay(VssTreeNode::RayInfo((*ri).mRay,
-																							(*ri).mRay->mT,
-																							(*ri).mMaxT));
-						front->AddRay(VssTreeNode::RayInfo((*ri).mRay,
-																							 (*ri).mMinT,
-																							 (*ri).mRay->mT));
-					}
-				} else
-					if (side == 1) 
-						front->AddRay(*ri);
-					else
-						back->AddRay(*ri);
+		// first unref ray from the former leaf
+		(*ri).mRay->Unref();
+
+		// Debug << "computed t: " << (*ri).mRay->mT << endl;
+		// determine the side of this ray with respect to the plane
+		int side = node->ComputeRayIntersection(*ri, (*ri).mRay->mT);
+		
+		if (side == 0) {
+		  if ((*ri).mRay->HasPosDir(axis)) {
+			back->AddRay(VssTreeNode::RayInfo((*ri).mRay,
+											  (*ri).mMinT,
+											  (*ri).mRay->mT)
+						 );
+			front->AddRay(VssTreeNode::RayInfo((*ri).mRay,
+											   (*ri).mRay->mT,
+											   (*ri).mMaxT));
+		  } else {
+			back->AddRay(VssTreeNode::RayInfo((*ri).mRay,
+											  (*ri).mRay->mT,
+											  (*ri).mMaxT));
+			front->AddRay(VssTreeNode::RayInfo((*ri).mRay,
+											   (*ri).mMinT,
+											   (*ri).mRay->mT));
+		  }
+		} else
+		  if (side == 1) 
+			front->AddRay(*ri);
+		  else
+			back->AddRay(*ri);
       } else
-				(*ri).mRay->Unref();
+		(*ri).mRay->Unref();
     }
   } else {
@@ -1020,26 +1087,29 @@
     
     for(VssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
-				ri != leaf->rays.end();
-				ri++) {
+		ri != leaf->rays.end();
+		ri++) {
       if ((*ri).mRay->IsActive()) {
-				// first unref ray from the former leaf
-				(*ri).mRay->Unref();
-
-				int side;
-				if ((*ri).mRay->GetDirParametrization(axis - 3) > position)
-					side = 1;
-				else
-					side = -1;
-				
-				if (side == 1)
-					front->AddRay(*ri);
-				else
-					back->AddRay(*ri);
+		// first unref ray from the former leaf
+		(*ri).mRay->Unref();
+
+		int side;
+		if ((*ri).mRay->GetDirParametrization(axis - 3) > position)
+		  side = 1;
+		else
+		  side = -1;
+				
+		if (side == 1)
+		  front->AddRay(*ri);
+		else
+		  back->AddRay(*ri);
 				
       } else
-				(*ri).mRay->Unref();
+		(*ri).mRay->Unref();
     }
   }
-	
+
+  front->SetPvsSize(pvsFront);
+  back->SetPvsSize(pvsBack);
+
   // update stats
   stat.rayRefs -= leaf->rays.size();
@@ -1076,16 +1146,16 @@
       //      cout<<"depth="<<(int)in->depth<<" time="<<in->lastAccessTime<<endl;
       if (in->depth >= minCollapseDepth &&
-	  in->lastAccessTime <= maxAccessTime) {
-	released = CollapseSubtree(node, time);
-	break;
+		  in->lastAccessTime <= maxAccessTime) {
+		released = CollapseSubtree(node, time);
+		break;
       }
       
       if (in->back->GetAccessTime() <  
-	  in->front->GetAccessTime()) {
-	tstack.push(in->front);
-	tstack.push(in->back);
+		  in->front->GetAccessTime()) {
+		tstack.push(in->front);
+		tstack.push(in->back);
       } else {
-	tstack.push(in->back);
-	tstack.push(in->front);
+		tstack.push(in->back);
+		tstack.push(in->front);
       }
     }
@@ -1106,6 +1176,6 @@
 VssTreeNode *
 VssTree::SubdivideLeaf(
-											 VssTreeLeaf *leaf
-											 )
+					   VssTreeLeaf *leaf
+					   )
 {
   VssTreeNode *node = leaf;
@@ -1113,11 +1183,11 @@
   AxisAlignedBox3 leafBBox = GetBBox(leaf);
 
-	static int pass = 0;
-	pass ++;
+  static int pass = 0;
+  pass ++;
 	
   // check if we should perform a dynamic subdivision of the leaf
-	if (!TerminationCriteriaSatisfied(leaf)) {
+  if (!TerminationCriteriaSatisfied(leaf)) {
     
-		// memory check and realese...
+	// memory check and realese...
     if (GetMemUsage() > maxTotalMemory) {
       ReleaseMemory( pass );
@@ -1129,8 +1199,8 @@
     node =
       SubdivideNode(leaf,
-										leafBBox,
-										backBBox,
-										frontBBox
-										);
+					leafBBox,
+					backBBox,
+					frontBBox
+					);
   }
 	
@@ -1142,6 +1212,6 @@
 void
 VssTree::UpdateRays(VssRayContainer &remove,
-										VssRayContainer &add
-										)
+					VssRayContainer &add
+					)
 {
   VssTreeLeaf::NewMail();
@@ -1160,6 +1230,6 @@
       ri++) {
     if ((*ri)->ScheduledForRemoval())
-//      RemoveRay(*ri, NULL, false);
-// !!! BUG - with true it does not work correctly - aggreated delete
+	  //      RemoveRay(*ri, NULL, false);
+	  // !!! BUG - with true it does not work correctly - aggreated delete
       RemoveRay(*ri, NULL, true);
     else
@@ -1173,7 +1243,7 @@
       ri != add.end();
       ri++) {
-		VssTreeNode::RayInfo info(*ri);
-		if (ClipRay(info, bbox))
-			AddRay(info);
+	VssTreeNode::RayInfo info(*ri);
+	if (ClipRay(info, bbox))
+	  AddRay(info);
   }
 }
@@ -1182,7 +1252,7 @@
 void
 VssTree::RemoveRay(VssRay *ray,
-									 vector<VssTreeLeaf *> *affectedLeaves,
-									 const bool removeAllScheduledRays
-									 )
+				   vector<VssTreeLeaf *> *affectedLeaves,
+				   const bool removeAllScheduledRays
+				   )
 {
 	
@@ -1211,45 +1281,45 @@
       
       if (!leaf->Mailed()) {
-	leaf->Mail();
-	if (affectedLeaves)
-	  affectedLeaves->push_back(leaf);
-	
-	if (removeAllScheduledRays) {
-	  int tail = leaf->rays.size()-1;
-
-	  for (int i=0; i < (int)(leaf->rays.size()); i++) {
-	    if (leaf->rays[i].mRay->ScheduledForRemoval()) {
-	      // find a ray to replace it with
-	      while (tail >= i && leaf->rays[tail].mRay->ScheduledForRemoval()) {
-		stat.removedRayRefs++;
-		leaf->rays[tail].mRay->Unref();
-		leaf->rays.pop_back();
-		tail--;
-	      }
-
-	      if (tail < i)
-		break;
+		leaf->Mail();
+		if (affectedLeaves)
+		  affectedLeaves->push_back(leaf);
+	
+		if (removeAllScheduledRays) {
+		  int tail = leaf->rays.size()-1;
+
+		  for (int i=0; i < (int)(leaf->rays.size()); i++) {
+			if (leaf->rays[i].mRay->ScheduledForRemoval()) {
+			  // find a ray to replace it with
+			  while (tail >= i && leaf->rays[tail].mRay->ScheduledForRemoval()) {
+				stat.removedRayRefs++;
+				leaf->rays[tail].mRay->Unref();
+				leaf->rays.pop_back();
+				tail--;
+			  }
+
+			  if (tail < i)
+				break;
 	      
-	      stat.removedRayRefs++;
-	      leaf->rays[i].mRay->Unref();
-	      leaf->rays[i] = leaf->rays[tail];
-	      leaf->rays.pop_back();
-	      tail--;
-	    }
-	  }
-	}
+			  stat.removedRayRefs++;
+			  leaf->rays[i].mRay->Unref();
+			  leaf->rays[i] = leaf->rays[tail];
+			  leaf->rays.pop_back();
+			  tail--;
+			}
+		  }
+		}
       }
       
       if (!removeAllScheduledRays)
-	for (int i=0; i < (int)leaf->rays.size(); i++) {
-	  if (leaf->rays[i].mRay == ray) {
-	    stat.removedRayRefs++;
-	    ray->Unref();
-	    leaf->rays[i] = leaf->rays[leaf->rays.size()-1];
-	    leaf->rays.pop_back();
-	    // check this ray again
-	    break;
-	  }
-	}
+		for (int i=0; i < (int)leaf->rays.size(); i++) {
+		  if (leaf->rays[i].mRay == ray) {
+			stat.removedRayRefs++;
+			ray->Unref();
+			leaf->rays[i] = leaf->rays[leaf->rays.size()-1];
+			leaf->rays.pop_back();
+			// check this ray again
+			break;
+		  }
+		}
       
     }
@@ -1292,6 +1362,6 @@
 void
 VssTree::TraverseInternalNode(
-															RayTraversalData &data,
-															stack<RayTraversalData> &tstack)
+							  RayTraversalData &data,
+							  stack<RayTraversalData> &tstack)
 {
   VssTreeInterior *in =  (VssTreeInterior *) data.node;
@@ -1301,35 +1371,35 @@
     // determine the side of this ray with respect to the plane
     int side = in->ComputeRayIntersection(data.rayData,
-																					data.rayData.mRay->mT);
+										  data.rayData.mRay->mT);
     
   
     if (side == 0) {
       if (data.rayData.mRay->HasPosDir(in->axis)) {
-				tstack.push(RayTraversalData(in->back,
-																		 VssTreeNode::RayInfo(data.rayData.mRay,
-																													data.rayData.mMinT,
-																													data.rayData.mRay->mT))
-										);
-				
-				tstack.push(RayTraversalData(in->front,
-																		 VssTreeNode::RayInfo(data.rayData.mRay,
-																													data.rayData.mRay->mT,
-																													data.rayData.mMaxT
-																													))
-										);
+		tstack.push(RayTraversalData(in->back,
+									 VssTreeNode::RayInfo(data.rayData.mRay,
+														  data.rayData.mMinT,
+														  data.rayData.mRay->mT))
+					);
+				
+		tstack.push(RayTraversalData(in->front,
+									 VssTreeNode::RayInfo(data.rayData.mRay,
+														  data.rayData.mRay->mT,
+														  data.rayData.mMaxT
+														  ))
+					);
 	
       } else {
-				tstack.push(RayTraversalData(in->back,
-																		 VssTreeNode::RayInfo(data.rayData.mRay,
-																													data.rayData.mRay->mT,
-																													data.rayData.mMaxT
-																													))
-										);
-				
-				tstack.push(RayTraversalData(in->front,
-																		 VssTreeNode::RayInfo(data.rayData.mRay,
-																													data.rayData.mMinT,
-																													data.rayData.mRay->mT))
-										);
+		tstack.push(RayTraversalData(in->back,
+									 VssTreeNode::RayInfo(data.rayData.mRay,
+														  data.rayData.mRay->mT,
+														  data.rayData.mMaxT
+														  ))
+					);
+				
+		tstack.push(RayTraversalData(in->front,
+									 VssTreeNode::RayInfo(data.rayData.mRay,
+														  data.rayData.mMinT,
+														  data.rayData.mRay->mT))
+					);
 				
 				
@@ -1337,14 +1407,14 @@
     } else
       if (side == 1)
-				tstack.push(RayTraversalData(in->front, data.rayData));
+		tstack.push(RayTraversalData(in->front, data.rayData));
       else
-				tstack.push(RayTraversalData(in->back, data.rayData));
+		tstack.push(RayTraversalData(in->back, data.rayData));
   } 
   else {
     // directional split
-		if (data.rayData.mRay->GetDirParametrization(in->axis - 3) > in->position)
-			tstack.push(RayTraversalData(in->front, data.rayData));
-		else
-			tstack.push(RayTraversalData(in->back, data.rayData));
+	if (data.rayData.mRay->GetDirParametrization(in->axis - 3) > in->position)
+	  tstack.push(RayTraversalData(in->front, data.rayData));
+	else
+	  tstack.push(RayTraversalData(in->back, data.rayData));
   }
 }
@@ -1367,7 +1437,7 @@
 #endif
 
-//    tstat.collapsedSubtrees++;
-//    tstat.collapseDepths += (int)sroot->depth;
-//    tstat.collapseAccessTimes += time - sroot->GetAccessTime();
+  //    tstat.collapsedSubtrees++;
+  //    tstat.collapseDepths += (int)sroot->depth;
+  //    tstat.collapseAccessTimes += time - sroot->GetAccessTime();
   
   tstack.push(sroot);
@@ -1382,12 +1452,12 @@
       VssTreeLeaf *leaf = (VssTreeLeaf *) node;
       for(VssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
-					ri != leaf->rays.end();
-					ri++) {
-				
-				totalRayCount++;
-				if ((*ri).mRay->IsActive() && !(*ri).mRay->Mailed()) {
-					(*ri).mRay->Mail();
-					rayCount++;
-				}
+		  ri != leaf->rays.end();
+		  ri++) {
+				
+		totalRayCount++;
+		if ((*ri).mRay->IsActive() && !(*ri).mRay->Mailed()) {
+		  (*ri).mRay->Mail();
+		  rayCount++;
+		}
       }
     } else {
@@ -1416,17 +1486,17 @@
       
       for(VssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
-					ri != leaf->rays.end();
-					ri++) {
-				
-				// unref this ray from the old node
-				
-				if ((*ri).mRay->IsActive()) {
-					(*ri).mRay->Unref();
-					if (!(*ri).mRay->Mailed()) {
-						(*ri).mRay->Mail();
-						newLeaf->AddRay(*ri);
-					}
-				} else
-					(*ri).mRay->Unref();
+		  ri != leaf->rays.end();
+		  ri++) {
+				
+		// unref this ray from the old node
+				
+		if ((*ri).mRay->IsActive()) {
+		  (*ri).mRay->Unref();
+		  if (!(*ri).mRay->Mailed()) {
+			(*ri).mRay->Mail();
+			newLeaf->AddRay(*ri);
+		  }
+		} else
+		  (*ri).mRay->Unref();
 				
       }
@@ -1440,8 +1510,8 @@
   delete sroot;
   
-//   for(VssTreeNode::SRayContainer::iterator ri = newLeaf->rays.begin();
-//       ri != newLeaf->rays.end();
-//       ri++)
-//     (*ri).ray->UnMail(2);
+  //   for(VssTreeNode::SRayContainer::iterator ri = newLeaf->rays.begin();
+  //       ri != newLeaf->rays.end();
+  //       ri++)
+  //     (*ri).ray->UnMail(2);
 
 
@@ -1460,6 +1530,6 @@
 #endif
 
-	//  tstat.collapsedNodes += collapsedNodes;
-	//  tstat.collapsedRays += totalRayCount - rayCount;
+  //  tstat.collapsedNodes += collapsedNodes;
+  //  tstat.collapsedRays += totalRayCount - rayCount;
     
   return totalRayCount - rayCount;
@@ -1468,11 +1538,11 @@
 
 int
-VssTree::GetPvsSize(VssTreeNode *node, const AxisAlignedBox3 &box) const
-{
-	stack<VssTreeNode *> tstack;
+VssTree::GetPvsSize(const AxisAlignedBox3 &box) const
+{
+  stack<VssTreeNode *> tstack;
   tstack.push(root);
 
-	Intersectable::NewMail();
-	int pvsSize = 0;
+  Intersectable::NewMail();
+  int pvsSize = 0;
 	
   while (!tstack.empty()) {
@@ -1482,55 +1552,55 @@
  
     if (node->IsLeaf()) {
-			VssTreeLeaf *leaf = (VssTreeLeaf *)node;
-			for(VssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
-					ri != leaf->rays.end();
-					ri++)
-				if ((*ri).mRay->IsActive()) {
-					Intersectable *object;
+	  VssTreeLeaf *leaf = (VssTreeLeaf *)node;
+	  for(VssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
+		  ri != leaf->rays.end();
+		  ri++)
+		if ((*ri).mRay->IsActive()) {
+		  Intersectable *object;
 #if BIDIRECTIONAL_RAY
-					object = (*ri).mRay->mOriginObject;
-					if (object && !object->Mailed()) {
-						pvsSize++;
-						object->Mail();
-					}
+		  object = (*ri).mRay->mOriginObject;
+		  if (object && !object->Mailed()) {
+			pvsSize++;
+			object->Mail();
+		  }
 #endif
-					object = (*ri).mRay->mTerminationObject;
-					if (object && !object->Mailed()) {
-						pvsSize++;
-						object->Mail();
-					}
-				}
-		} else {
-			VssTreeInterior *in = (VssTreeInterior *)node;
-			if (in->axis < 3) {
-				if (box.Max(in->axis) >= in->position )
-					tstack.push(in->front);
-				
-				if (box.Min(in->axis) <= in->position )
-					tstack.push(in->back);
-			} else {
-				// both nodes for directional splits
-				tstack.push(in->front);
-				tstack.push(in->back);
-			}
+		  object = (*ri).mRay->mTerminationObject;
+		  if (object && !object->Mailed()) {
+			pvsSize++;
+			object->Mail();
+		  }
 		}
-	}
-	return pvsSize;
+	} else {
+	  VssTreeInterior *in = (VssTreeInterior *)node;
+	  if (in->axis < 3) {
+		if (box.Max(in->axis) >= in->position )
+		  tstack.push(in->front);
+				
+		if (box.Min(in->axis) <= in->position )
+		  tstack.push(in->back);
+	  } else {
+		// both nodes for directional splits
+		tstack.push(in->front);
+		tstack.push(in->back);
+	  }
+	}
+  }
+  return pvsSize;
 }
 
 void
 VssTree::GetRayContributionStatistics(
-																			float &minRayContribution,
-																			float &maxRayContribution,
-																			float &avgRayContribution
-																			)
-{
-	stack<VssTreeNode *> tstack;
+									  float &minRayContribution,
+									  float &maxRayContribution,
+									  float &avgRayContribution
+									  )
+{
+  stack<VssTreeNode *> tstack;
   tstack.push(root);
 	
-	minRayContribution = 1.0f;
-	maxRayContribution = 0.0f;
-	float sumRayContribution = 0.0f;
-	int leaves = 0;
+  minRayContribution = 1.0f;
+  maxRayContribution = 0.0f;
+  float sumRayContribution = 0.0f;
+  int leaves = 0;
 
   while (!tstack.empty()) {
@@ -1539,24 +1609,24 @@
 		
     if (node->IsLeaf()) {
-			leaves++;
-			VssTreeLeaf *leaf = (VssTreeLeaf *)node;
-			float c = leaf->GetAvgRayContribution();
-			if (c > maxRayContribution)
-				maxRayContribution = c;
-			if (c < minRayContribution)
-				minRayContribution = c;
-			sumRayContribution += c;
+	  leaves++;
+	  VssTreeLeaf *leaf = (VssTreeLeaf *)node;
+	  float c = leaf->GetAvgRayContribution();
+	  if (c > maxRayContribution)
+		maxRayContribution = c;
+	  if (c < minRayContribution)
+		minRayContribution = c;
+	  sumRayContribution += c;
 			
-		} else {
-			VssTreeInterior *in = (VssTreeInterior *)node;
-			// both nodes for directional splits
-			tstack.push(in->front);
-			tstack.push(in->back);
-		}
-	}
-	
-	cout<<"sum="<<sumRayContribution<<endl;
-	cout<<"leaves="<<leaves<<endl;
-	avgRayContribution = sumRayContribution/(float)leaves;
+	} else {
+	  VssTreeInterior *in = (VssTreeInterior *)node;
+	  // both nodes for directional splits
+	  tstack.push(in->front);
+	  tstack.push(in->back);
+	}
+  }
+	
+  cout<<"sum="<<sumRayContribution<<endl;
+  cout<<"leaves="<<leaves<<endl;
+  avgRayContribution = sumRayContribution/(float)leaves;
 }
 
@@ -1564,7 +1634,7 @@
 int
 VssTree::GenerateRays(const float ratioPerLeaf,
-											SimpleRayContainer &rays)
-{
-	stack<VssTreeNode *> tstack;
+					  SimpleRayContainer &rays)
+{
+  stack<VssTreeNode *> tstack;
   tstack.push(root);
 	
@@ -1574,26 +1644,26 @@
 		
     if (node->IsLeaf()) {
-			VssTreeLeaf *leaf = (VssTreeLeaf *)node;
-			float c = leaf->GetAvgRayContribution();
-			int num = (c*ratioPerLeaf + 0.5);
-			//			cout<<num<<" ";
-
-			for (int i=0; i < num; i++) {
-				Vector3 origin = GetBBox(leaf).GetRandomPoint();
-				Vector3 dirVector = GetDirBBox(leaf).GetRandomPoint();
-				Vector3 direction = Vector3(sin(dirVector.x), sin(dirVector.y), cos(dirVector.x));
-				//cout<<"dir vector.x="<<dirVector.x<<"direction'.x="<<atan2(direction.x, direction.y)<<endl;
-				rays.push_back(SimpleRay(origin, direction));
-			}
+	  VssTreeLeaf *leaf = (VssTreeLeaf *)node;
+	  float c = leaf->GetAvgRayContribution();
+	  int num = (c*ratioPerLeaf + 0.5);
+	  //			cout<<num<<" ";
+
+	  for (int i=0; i < num; i++) {
+		Vector3 origin = GetBBox(leaf).GetRandomPoint();
+		Vector3 dirVector = GetDirBBox(leaf).GetRandomPoint();
+		Vector3 direction = VssRay::GetDirection(dirVector.x, dirVector.y);
+		//cout<<"dir vector.x="<<dirVector.x<<"direction'.x="<<atan2(direction.x, direction.y)<<endl;
+		rays.push_back(SimpleRay(origin, direction));
+	  }
 			
-		} else {
-			VssTreeInterior *in = (VssTreeInterior *)node;
-			// both nodes for directional splits
-			tstack.push(in->front);
-			tstack.push(in->back);
-		}
-	}
-
-	return rays.size();
+	} else {
+	  VssTreeInterior *in = (VssTreeInterior *)node;
+	  // both nodes for directional splits
+	  tstack.push(in->front);
+	  tstack.push(in->back);
+	}
+  }
+
+  return rays.size();
 }
 
@@ -1601,5 +1671,5 @@
 VssTree::CollectLeaves(vector<VssTreeLeaf *> &leaves)
 {
-	stack<VssTreeNode *> tstack;
+  stack<VssTreeNode *> tstack;
   tstack.push(root);
 	
@@ -1609,56 +1679,120 @@
 		
     if (node->IsLeaf()) {
-			VssTreeLeaf *leaf = (VssTreeLeaf *)node;
-			leaves.push_back(leaf);
-		} else {
-			VssTreeInterior *in = (VssTreeInterior *)node;
-			// both nodes for directional splits
-			tstack.push(in->front);
-			tstack.push(in->back);
-		}
-	}
+	  VssTreeLeaf *leaf = (VssTreeLeaf *)node;
+	  leaves.push_back(leaf);
+	} else {
+	  VssTreeInterior *in = (VssTreeInterior *)node;
+	  // both nodes for directional splits
+	  tstack.push(in->front);
+	  tstack.push(in->back);
+	}
+  }
+}
+
+bool
+VssTree::ValidLeaf(VssTreeLeaf *leaf) const
+{
+  return leaf->rays.size() > termMinRays/4;
+}
+
+void
+GenerateExtendedConvexCombinationWeights(float &w1,
+										 float &w2,
+										 float &w3,
+										 const float overlap
+										 )
+{
+  w1 = RandomValue(-overlap, 1.0f + overlap);
+  w2 = RandomValue(-overlap, 1.0f + overlap);
+  w3 = RandomValue(-overlap, 1.0f + overlap);
+	
+  float c = 1.0f/(w1 + w2 + w3);
+  w1 *= c;
+  w2 *= c;
+  w3 *= c;
+}
+
+void
+VssTree::GenerateLeafRays(VssTreeLeaf *leaf,
+						  const int numberOfRays,
+						  SimpleRayContainer &rays)
+{
+  int nrays = leaf->rays.size();
+  for (int i=0; i < numberOfRays; i++) {
+	// pickup 3 random rays
+	int r1 = Random(nrays-1);
+	int r2 = Random(nrays-1);
+	int r3 = Random(nrays-1);
+		
+	Vector3 o1 = leaf->rays[r1].Extrap(RandomValue(leaf->rays[r1].GetMinT(), 
+												   leaf->rays[r1].GetMaxT()));
+
+	Vector3 o2 = leaf->rays[r2].Extrap(RandomValue(leaf->rays[r2].GetMinT(), 
+												   leaf->rays[r2].GetMaxT()));
+		
+	Vector3 o3 = leaf->rays[r3].Extrap(RandomValue(leaf->rays[r3].GetMinT(), 
+												   leaf->rays[r3].GetMaxT()));
+
+	const float overlap = 0.1;
+		
+	Vector3 origin, direction;
+	bool useExtendedConvexCombination = true;
+	if (useExtendedConvexCombination) {
+	  float w1, w2, w3;
+	  GenerateExtendedConvexCombinationWeights(w1, w2, w3, overlap);
+	  origin = w1*o1 + w2*o2 + w3*o3;
+	  direction =
+		w1*leaf->rays[r1].mRay->GetDir() +
+		w2*leaf->rays[r2].mRay->GetDir() +
+		w3*leaf->rays[r3].mRay->GetDir();
+	} else {
+	  origin = GetBBox(leaf).GetRandomPoint();
+	  Vector3 dirVector = GetDirBBox(leaf).GetRandomPoint();
+	  direction = Vector3(sin(dirVector.x), sin(dirVector.y), cos(dirVector.x));
+	}
+	//cout<<"dir vector.x="<<dirVector.x<<"direction'.x="<<atan2(direction.x, direction.y)<<endl;
+	rays.push_back(SimpleRay(origin, direction));
+  }
 }
 
 int
 VssTree::GenerateRays(const int numberOfRays,
-											const int numberOfLeaves,
-											SimpleRayContainer &rays)
-{
-
-	vector<VssTreeLeaf *> leaves;
-	
-	CollectLeaves(leaves);
-	
-	sort(leaves.begin(),
-			 leaves.end(),
-			 GreaterContribution);
+					  const int numberOfLeaves,
+					  SimpleRayContainer &rays)
+{
+
+  vector<VssTreeLeaf *> leaves;
+	
+  CollectLeaves(leaves);
+	
+  sort(leaves.begin(),
+	   leaves.end(),
+	   GreaterContribution);
 			 
 
-	float sumContrib = 0.0;
-	int i;
-	for (i=0; i < numberOfLeaves; i++) {
-		float c = leaves[i]->GetAvgRayContribution();
-		sumContrib += c;
-		//		cout<<"ray contrib "<<i<<" : "<<c<<endl;
-	}
-
-	float avgContrib = sumContrib/numberOfLeaves;
-	float ratioPerLeaf = numberOfRays/(avgContrib*numberOfLeaves);
-	
-	for (i=0; i < numberOfLeaves; i++) {
-		VssTreeLeaf *leaf = leaves[i];
-		float c = leaf->GetAvgRayContribution();
-		int num = (c*ratioPerLeaf + 0.5);
-		//			cout<<num<<" ";
-		
-		for (int i=0; i < num; i++) {
-			Vector3 origin = GetBBox(leaf).GetRandomPoint();
-			Vector3 dirVector = GetDirBBox(leaf).GetRandomPoint();
-			Vector3 direction = Vector3(sin(dirVector.x), sin(dirVector.y), cos(dirVector.x));
-			//cout<<"dir vector.x="<<dirVector.x<<"direction'.x="<<atan2(direction.x, direction.y)<<endl;
-			rays.push_back(SimpleRay(origin, direction));
-		}
-	}
-	return rays.size();
+  float sumContrib = 0.0;
+  int i;
+  int k = 0;
+  for (i=0; i < leaves.size() && k < numberOfLeaves; i++)
+	if (ValidLeaf(leaves[i])) {
+	  float c = leaves[i]->GetAvgRayContribution();
+	  sumContrib += c;
+	  //		cout<<"ray contrib "<<i<<" : "<<c<<endl;
+	  k++;
+	}
+				
+  float avgContrib = sumContrib/numberOfLeaves;
+  float ratioPerLeaf = numberOfRays/(avgContrib*numberOfLeaves);
+  k = 0;
+  for (i=0; i < leaves.size() && k < numberOfLeaves; i++)
+	if (ValidLeaf(leaves[i])) {
+	  k++;
+	  VssTreeLeaf *leaf = leaves[i];
+	  float c = leaf->GetAvgRayContribution();
+	  int num = (c*ratioPerLeaf + 0.5);
+	  GenerateLeafRays(leaf, num, rays);
+	}
+
+  return rays.size();
 }
 
@@ -1667,9 +1801,9 @@
 VssTree::GetAvgPvsSize()
 {
-	stack<VssTreeNode *> tstack;
+  stack<VssTreeNode *> tstack;
   tstack.push(root);
 
-	int sumPvs = 0;
-	int leaves = 0;
+  int sumPvs = 0;
+  int leaves = 0;
   while (!tstack.empty()) {
     VssTreeNode *node = tstack.top();
@@ -1677,20 +1811,20 @@
 		
     if (node->IsLeaf()) {
-			VssTreeLeaf *leaf = (VssTreeLeaf *)node;
-			// update pvs size
-			leaf->UpdatePvsSize();
-			sumPvs += leaf->GetPvsSize();
-			leaves++;
-		} else {
-			VssTreeInterior *in = (VssTreeInterior *)node;
-			// both nodes for directional splits
-			tstack.push(in->front);
-			tstack.push(in->back);
-		}
-	}
-
-
-	return sumPvs/(float)leaves;
-}
-
-	
+	  VssTreeLeaf *leaf = (VssTreeLeaf *)node;
+	  // update pvs size
+	  leaf->UpdatePvsSize();
+	  sumPvs += leaf->GetPvsSize();
+	  leaves++;
+	} else {
+	  VssTreeInterior *in = (VssTreeInterior *)node;
+	  // both nodes for directional splits
+	  tstack.push(in->front);
+	  tstack.push(in->back);
+	}
+  }
+
+
+  return sumPvs/(float)leaves;
+}
+
+	
Index: trunk/VUT/GtpVisibilityPreprocessor/src/X3dExporter.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/X3dExporter.h	(revision 425)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/X3dExporter.h	(revision 434)
@@ -38,5 +38,8 @@
   bool
   ExportKdTree(const KdTree &tree);
-  
+
+	bool
+  ExportVssTree(const VssTree &tree);
+
   bool 
   ExportVspKdTree(const VspKdTree &tree, const int maxPvs);
@@ -108,5 +111,10 @@
 
   bool
-  ExportBspTreeRayDensity(const BspTree &tree);  
+  ExportBspTreeRayDensity(const BspTree &tree);
+
+	void
+	AddBoxToMesh(const AxisAlignedBox3 &box,
+							 Mesh *mesh);
+		
 };
  
Index: trunk/VUT/GtpVisibilityPreprocessor/src/VssRay.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/VssRay.h	(revision 431)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/VssRay.h	(revision 434)
@@ -136,4 +136,8 @@
   Vector3 GetNormalizedDir() const { return (mTermination - mOrigin)*mInvSize; }
 
+	Vector3 Extrap(const float t) const {
+		return GetOrigin() + t * GetDir();
+	}
+	
 	float GetDirParametrization(const int axis) const;
 	
@@ -200,4 +204,10 @@
       }
   }
+
+	static Vector3
+	GetDirection(const float a, const float b) {
+		return Vector3(sin(a), sin(b), cos(a));
+	}
+
 };
 
